"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.configProviderForObject = void 0;
const objectPath = require("object-path");
const errors_1 = require("./errors");
function configProviderForObject(config) {
    return (request) => {
        const result = objectPath.get(config, request.path);
        if (result === undefined) {
            if (request.hasDefaultValue) {
                return request.defaultValue;
            }
            throw errors_1.ERRORS.MISSING_CONFIG_VALUE.create(request.path);
        }
        return result;
    };
}
exports.configProviderForObject = configProviderForObject;
