"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigRequestArg = void 0;
const is = require("predicates");
const ContainerArg_1 = require("./ContainerArg");
const config_1 = require("../middlewares/config");
const assertNotBlank = is.assert(is.notBlank, 'Config "path" cannot be blank');
class ConfigRequestArg extends ContainerArg_1.ContainerArg {
    constructor(path, defaultValue) {
        super();
        this.path = path;
        this.defaultValue = defaultValue;
        assertNotBlank(this.path);
        this.hasDefaultValue = arguments.length > 1;
        Object.freeze(this);
    }
    static create(...args) {
        return new ConfigRequestArg(...args);
    }
    // eslint-disable-next-line @typescript-eslint/require-await
    async getArgument(container) {
        return (0, config_1.getConfigProviderForContainer)(container)(this);
    }
    getDependentServices(container) {
        return [];
    }
}
exports.ConfigRequestArg = ConfigRequestArg;
