import { ContainerArg } from "./ContainerArg";
import { Container } from "../Container";
import { Definition } from "../Definition";
/**
 * Resolves all ContainerArg in provided value
 */
export declare class ResolveArg<T extends object> extends ContainerArg<ResolveArg.Resolved<T>> {
    private readonly value;
    constructor(value: T | (() => T));
    getArgument(container: Container): Promise<ResolveArg.Resolved<T>>;
    private getValue;
    private transformObject;
    private reducer;
    private collectContainerArgsFromResult;
    getDependentServices(container: Container): Definition | Definition[];
}
export declare namespace ResolveArg {
    type Resolved<T> = T extends ContainerArg<infer U> ? U : T extends Array<infer B> ? Array<Resolved<B>> : T extends object ? {
        [P in keyof T]: Resolved<T[P]>;
    } : T;
}
