"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Annotation = void 0;
const serviceMetadata_1 = require("../serviceMetadata");
const ServiceNoAutoRegister_1 = require("./ServiceNoAutoRegister");
// eslint-disable-next-line @typescript-eslint/naming-convention
function Annotation(annotation) {
    return (clazz) => {
        const definition = (0, ServiceNoAutoRegister_1.getDefinitionForClass)(clazz);
        if (definition) {
            definition.annotate(annotation);
        }
        (0, serviceMetadata_1.ensureMetadata)(clazz).annotations.push(annotation);
    };
}
exports.Annotation = Annotation;
