"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = void 0;
const ConfigRequestArg_1 = require("../args/ConfigRequestArg");
const serviceMetadata_1 = require("../serviceMetadata");
// eslint-disable-next-line @typescript-eslint/naming-convention
function Config(...args) {
    const request = ConfigRequestArg_1.ConfigRequestArg.create(...args);
    return function (target, property, indexOrDescriptor) {
        const isParameterDecorator = typeof indexOrDescriptor === "number";
        if (isParameterDecorator) {
            (0, serviceMetadata_1.ensureMetadata)(target).constructorArguments[indexOrDescriptor] = request;
        }
        else if (property) {
            (0, serviceMetadata_1.ensureMetadata)(target.constructor).propertiesInjectors.set(property, request);
        }
    };
}
exports.Config = Config;
