"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Service = void 0;
require("reflect-metadata");
const ServiceNoAutoRegister_1 = require("./ServiceNoAutoRegister");
exports.Service = function (name) {
    return function (constructor) {
        (0, ServiceNoAutoRegister_1.ServiceNoAutoRegister)(name)(constructor);
        if (exports.Service._container) {
            exports.Service._container.registerDefinition((0, ServiceNoAutoRegister_1.getDefinitionForClass)(constructor));
        }
        else if (!process.env.ALPHA_DIC_NO_SERVICE_CONTAINER) {
            // eslint-disable-next-line no-console
            console.warn("There is no container registered in @Service decorator. " +
                "Use Service.useContainer(container) to define the container. " +
                "Without it service definitions created via @Service decorator cannot be registered automatically. " +
                "If you wish to register service definitions manually via getDefinitionForClass set ALPHA_DIC_NO_SERVICE_CONTAINER environment variable to disable this warning.");
        }
    };
};
exports.Service.useContainer = function (container) {
    exports.Service._container = container;
};
