"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefinitionForClass = exports.ServiceNoAutoRegister = void 0;
const serviceMetadata_1 = require("../serviceMetadata");
require("reflect-metadata");
const randomName_1 = require("../randomName");
const DEFINITION_KEY = Symbol("__alphaDic-ServiceDefinition");
const ServiceNoAutoRegister = function (name) {
    return function (constructor) {
        const finalName = name || (0, randomName_1.randomName)(constructor.name);
        const metadata = (0, serviceMetadata_1.ensureMetadata)(constructor);
        metadata.name = finalName;
        const definition = (0, serviceMetadata_1.createDefinitionFromMetadata)(metadata, constructor);
        Reflect.defineMetadata(DEFINITION_KEY, definition, constructor);
    };
};
exports.ServiceNoAutoRegister = ServiceNoAutoRegister;
function getDefinitionForClass(clazz) {
    return Reflect.getMetadata(DEFINITION_KEY, clazz);
}
exports.getDefinitionForClass = getDefinitionForClass;
