import { Domain, ErrorDescriptor } from "@pallad/errors";
import { Lookup } from "./Lookup";
export declare const errorsDomain: Domain;
export declare const ERRORS: {
    SERVICE_NOT_FOUND: ErrorDescriptor<(name: string) => Error, string>;
    AMBIGUOUS_SERVICE: ErrorDescriptor<(serviceNameList: string[], lookup: Lookup) => Error, string>;
    NO_MATCHING_SERVICE: ErrorDescriptor<(lookup: Lookup) => Error, string>;
    CIRCULAR_DEPENDENCY_DETECTED: ErrorDescriptor<(dependencyNameList: string[]) => Error, string>;
    INCOMPLETE_DEFINITION: ErrorDescriptor<(definitionName: string) => Error, string>;
    INVALID_SERVICE_ARGUMENTS_LENGTH: ErrorDescriptor<(name: string, requiredArgumentsLength: number, providedArgumentsLength: number) => Error, string>;
    MISSING_INJECT_DECORATOR: ErrorDescriptor<(position: number) => Error, string>;
    MISSING_CONFIG_VALUE: ErrorDescriptor<(path: string) => Error, string>;
    ALREADY_DEFINED: ErrorDescriptor<(name: string) => Error, string>;
    AUTO_WIRING_FAILED: ErrorDescriptor<(typeDescription: string) => Error, string>;
    AUTO_WIRING_NO_METADATA: ErrorDescriptor<(message?: string | undefined) => Error, string>;
    CONFIG_PROVIDER_NOT_ATTACHED: ErrorDescriptor<(message?: string | undefined) => Error, string>;
    OWNER_CANNOT_BE_CHANGED: ErrorDescriptor<(message?: string | undefined) => Error, string>;
    DEFINITION_WITHOUT_CONTAINER: ErrorDescriptor<(name: string) => Error, string>;
};
